import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

public class MyDijkstra {
    public static HashMap<Node, Double> dijkstra(Graph g, Node sommetDepart){
        //La hashmap associe chaque node avec une distance qui commence a l'infini sauf pour la node de départ
        HashMap<Node, Double> HMDistance = new HashMap<>();
        for(Node n : g){
            HMDistance.put(n, Double.POSITIVE_INFINITY);
        }
        HMDistance.replace(sommetDepart,.0);

        //La liste sert à suivre les nodes qui ont été traité.
        ArrayList<Node> listTraites = new ArrayList<>();
        //La node u est la node qui est actuellement traité
        Node u = sommetDepart;
        //L'itérateur permet de boucler sur les voisins de u
        Iterator<Node> it;

        while(u != null){
            listTraites.add(u);
            it = u.getNeighborNodeIterator();
            while (it.hasNext()){
                Node vDeU = it.next();
                HMDistance.replace(vDeU,
                        Math.min(HMDistance.get(vDeU),
                                HMDistance.get(u) + (Integer)u.getEdgeBetween(vDeU).getAttribute("Poids")));
            }
            u = argmin(HMDistance,listTraites);
        }

        return HMDistance;
    }

    //Méthode qui retourne la node avec la plus petite distance du sommet mais qui n'est pas traité dans la liste t
    public static Node argmin(HashMap<Node, Double> hashMap, ArrayList<Node> t){
        Double distanceMin = Double.POSITIVE_INFINITY;
        Node n = null;

        for(Node node : hashMap.keySet())
            if(!t.contains(node)){
                Double dTmp = hashMap.get(node);
                if(dTmp < distanceMin){
                    distanceMin = dTmp;
                    n = node;
                }
            }
        return n;
    }
}