import org.graphstream.algorithm.Dijkstra;
import org.graphstream.algorithm.generator.Generator;
import org.graphstream.algorithm.generator.RandomGenerator;
import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.implementations.SingleGraph;

public class TestDijkstra {

    public static void main(String[] args) {
        /*---------------------*/
        /*--Création du graphe-*/
        /*---------------------*/
        Graph graph = new SingleGraph("Random");
        Generator gen = new RandomGenerator(4);
        gen.addSink(graph);
        gen.begin();
        for(int i=0; i<1000; i++)
            gen.nextEvents();
        gen.end();

        for(Edge e : graph.getEachEdge())
            e.addAttribute("Poids",(int)(Math.random()*50)+1);


        /*---------------------------*/
        /*--Dijkstra de GrapheStream-*/
        /*---------------------------*/
        long temps = System.currentTimeMillis();
        Dijkstra dijkstra = new Dijkstra(Dijkstra.Element.EDGE, null, "length");
        dijkstra.init(graph);
        dijkstra.setSource(graph.getNode(0));
        dijkstra.compute();
        System.out.println(System.currentTimeMillis() - temps + " ms pour " + graph.getNodeCount() + " sommet(s)");

        /*---------------------*/
        /*--Dijkstra Personnel-*/
        /*---------------------*/
        temps = System.currentTimeMillis();
        MyDijkstra.dijkstra(graph, graph.getNode(0));
        System.out.println(System.currentTimeMillis() - temps + " ms pour " + graph.getNodeCount() + " sommet(s)");

    }

}